## iwrite-3.0.1.0.tar.gz

=== Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2015-2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

.SILENT:

UNAME:= $(shell uname)
BITS:= $(shell uname -m)

ifndef prefix
	ifeq ($(UNAME), OpenBSD)
		prefix=/usr/local
	else ifeq ($(UNAME), FreeBSD)
		prefix=/usr/local
	else ifeq ($(UNAME), NetBSD)
		prefix=/usr/pkg
	else
		prefix=/usr
	endif
endif

ifndef BINDIR
	BINDIR=${prefix}/bin
endif

ifndef LIBDIR
	LIBDIR=${prefix}/lib

	ifeq ($(UNAME), Linux)
		ifeq ($(BITS), x86_64)
			LIBDIR=${prefix}/lib64
		endif
	endif
endif

ifndef DATADIR
	DATADIR=${prefix}/share/iwrite
endif

UIDIR=${DATADIR}/ui

ifndef DOCDIR
	DOCDIR=${prefix}/share/doc/iwrite
endif

ifeq ($(UNAME), Linux)
	CFGFILE=data/iwrite_driver.cfg_linux
else ifeq ($(UNAME), NetBSD)
	CFGFILE=data/iwrite_driver.cfg_netbsd
else
	CFGFILE=data/iwrite_driver.cfg_bsd
endif

#CFGDIR=`echo ${XDG_CONFIG_DIRS} | cut -d ":" -f 1`
ifeq ($(UNAME), NetBSD)
	CFGDIR=${prefix}/etc/xdg
else ifeq ($(UNAME), FreeBSD)
	CFGDIR=${prefix}/etc/xdg
else
	CFGDIR=/etc/xdg
endif

.PHONY: all
all: docs iwrite drivers

.PHONY: docs
docs: doc/iwrite.pdf
	@echo finished documentation

doc/iwrite.pdf:
	@cd doc && ${MAKE}

.PHONY: iwrite
iwrite: src/iwrite
	@echo finished iwrite

src/iwrite: 
	@cd src && ${MAKE}

.PHONY: drivers
ifeq ($(UNAME), Linux)
drivers:\
	drivers/postgres/libiwsql_pq.so \
	drivers/mariadb/libiwsql_mariadb.so \
	drivers/sqlite3/libiwsql_sqlite3.so \
	drivers/oracle/libiwsql_oracle.so
else
drivers:\
	drivers/postgres/libiwsql_pq.so \
	drivers/mariadb/libiwsql_mariadb.so \
	drivers/sqlite3/libiwsql_sqlite3.so
endif
	@echo finished database drivers

drivers/postgres/libiwsql_pq.so: 
	@cd drivers && ${MAKE} postgres

drivers/mariadb/libiwsql_mariadb.so:
	@cd drivers && ${MAKE} mariadb

drivers/sqlite3/libiwsql_sqlite3.so:
	@cd drivers && ${MAKE} sqlite3

drivers/oracle/libiwsql_oracle.so:
	@cd drivers && ${MAKE} oracle

.PHONY: clean
clean:
	@echo making clean
	cd drivers && ${MAKE} clean
	cd src/decNumber && ${MAKE} clean
	cd src/icu && ${MAKE} clean
	cd src/ruler && ${MAKE} clean
	cd src/geometry && ${MAKE} clean
	cd src/zint && ${MAKE} clean
	cd src && ${MAKE} clean

.PHONY: install
install:
	@echo installing iwrite
	test -d ${DESTDIR}${BINDIR} || mkdir -p ${DESTDIR}${BINDIR}
	test -d ${DESTDIR}${LIBDIR} || mkdir -p ${DESTDIR}${LIBDIR}
	test -d ${DESTDIR}${CFGDIR} || mkdir -p ${DESTDIR}${CFGDIR}
	test -d ${DESTDIR}${DOCDIR} || mkdir -p ${DESTDIR}${DOCDIR}
	test -d ${DESTDIR}${DATADIR} || mkdir -p ${DESTDIR}${DATADIR}
	test -d ${DESTDIR}${UIDIR} || mkdir -p ${DESTDIR}${UIDIR}
	install -s -m 0655 src/iwrite ${DESTDIR}${BINDIR}/iwrite
	install -s -m 0755 drivers/postgres/libiwsql_pq.so ${DESTDIR}${LIBDIR}/libiwsql_pq.so 
	install -s -m 0755 drivers/mariadb/libiwsql_mariadb.so ${DESTDIR}${LIBDIR}/libiwsql_mariadb.so 
	install -s -m 0755 drivers/sqlite3/libiwsql_sqlite3.so ${DESTDIR}${LIBDIR}/libiwsql_sqlite3.so 
ifeq ($(UNAME), Linux)
	install -s -m 0755 drivers/oracle/libiwsql_oracle.so ${DESTDIR}${LIBDIR}/libiwsql_oracle.so 
endif
	install -m 0644 ${CFGFILE} ${DESTDIR}${CFGDIR}/iwrite_driver.cfg
	install -m 0444 README ${DESTDIR}${DOCDIR}/README
	install -m 0444 COPYING ${DESTDIR}${DOCDIR}/COPYING
	install -m 0444 doc/iwrite.pdf ${DESTDIR}${DOCDIR}/iwrite.pdf
	install -m 0644 src/break.glade ${DESTDIR}${UIDIR}/break.glade
	install -m 0644 src/circle.glade ${DESTDIR}${UIDIR}/circle.glade
	install -m 0644 src/database.glade ${DESTDIR}${UIDIR}/database.glade
	install -m 0644 src/date.glade ${DESTDIR}${UIDIR}/date.glade
	install -m 0644 src/export.glade ${DESTDIR}${UIDIR}/export.glade
	install -m 0644 src/export_page_setup.glade ${DESTDIR}${UIDIR}/export_page_setup.glade
	install -m 0644 src/fbarcode.glade ${DESTDIR}${UIDIR}/fbarcode.glade
	install -m 0644 src/field.glade ${DESTDIR}${UIDIR}/field.glade
	install -m 0644 src/fimage.glade ${DESTDIR}${UIDIR}/fimage.glade
	install -m 0644 src/fnumber.glade ${DESTDIR}${UIDIR}/fnumber.glade
	install -m 0644 src/frame.glade ${DESTDIR}${UIDIR}/frame.glade
	install -m 0644 src/fsum.glade ${DESTDIR}${UIDIR}/fsum.glade
	install -m 0644 src/ftext.glade ${DESTDIR}${UIDIR}/ftext.glade
	install -m 0644 src/image.glade ${DESTDIR}${UIDIR}/image.glade
	install -m 0644 src/label_page_setup.glade ${DESTDIR}${UIDIR}/label_page_setup.glade
	install -m 0644 src/layout_page_setup.glade ${DESTDIR}${UIDIR}/layout_page_setup.glade
	install -m 0644 src/line.glade ${DESTDIR}${UIDIR}/line.glade
	install -m 0644 src/mainwindow.glade ${DESTDIR}${UIDIR}/mainwindow.glade
	install -m 0644 src/page_number.glade ${DESTDIR}${UIDIR}/page_number.glade
	install -m 0644 src/query.glade ${DESTDIR}${UIDIR}/query.glade
	install -m 0644 src/README.glade ${DESTDIR}${UIDIR}/README
	install -m 0644 src/runreport.glade ${DESTDIR}${UIDIR}/runreport.glade
	install -m 0644 src/scrollwin.glade ${DESTDIR}${UIDIR}/scrollwin.glade
	install -m 0644 src/text.glade ${DESTDIR}${UIDIR}/text.glade

.PHONY: uninstall
uninstall:
	@echo uninstalling iwrite
	@rm -f ${DESTDIR}${BINDIR}/iwrite
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_pq.so 
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_mariadb.so 
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_sqlite3.so 
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_oracle.so 
	@rm -f ${DESTDIR}${CFGDIR}/iwrite_driver.cfg
	@rm -rf ${DESTDIR}${DOCDIR}
	@rm -rf ${DESTDIR}${DATADIR}

=== doc/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


iwrite.pdf: \
	commandline.tex\
	files.tex\
	iwrite.tex\
	license.tex\
	menu_sql.tex\
	menu.tex
	pdflatex iwrite.tex

=== drivers/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2015-2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

UNAME:= $(shell uname)

.PHONY: all
all: postgres sqlite3 mariadb oracle

.PHONY: postgres
postgres:
	@echo PostgreSQL
	cd postgres && ${MAKE} 

.PHONY: sqlite3
sqlite3:
	@echo SQLite
	cd sqlite3 && ${MAKE} 

.PHONY: mariadb
mariadb:
	@echo MariaDB
	cd mariadb && ${MAKE}

.PHONY: oracle
ifeq ($(UNAME), Linux)
oracle:
	@echo Oracle
	cd oracle && ${MAKE}
else
oracle:
	@echo Oracle not suppported on ${UNAME}
endif

.PHONY: clean
clean:
	cd postgres && ${MAKE} clean
	cd sqlite3 && ${MAKE} clean
	cd mariadb && ${MAKE} clean
	cd oracle && ${MAKE} clean

=== src/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2015-2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

UNAME:= $(shell uname)

ifeq ($(UNAME), Linux)
LDFLAGS+= -ldl -lX11
PNG_LIB= -l png
else
LDFLAGS+= -Wl,-R/usr/X11R7/lib
PNG_LIB= -l png16
endif

ifeq ($(UNAME), FreeBSD)
LDFLAGS+= -lX11
endif

# use icu-config?
ICU4=`pkg-config --cflags icu-uc icu-io`
ICU4_LIB=`pkg-config --libs icu-uc icu-io`

GTK=`pkg-config gtk+-3.0 --cflags`
GTK_LIB=`pkg-config gtk+-3.0 --libs`

GMODULE=`pkg-config gmodule-export-2.0 --cflags`
GMODULE_LIB=`pkg-config gmodule-export-2.0 --libs`

ICU=-I icu/
ICU_LIB=-L icu/ -licu

DECN=-I decNumber/
DECN_LIB=-L decNumber/ -ldecnumber

IWSQL_DRIVER=-I../drivers/include

GEOM=-I geometry/
GEOM_LIB=-L geometry/ -lgeometry

ZINT=-I zint/
ZINT_LIB=zint/libzint.a ${PNG_LIB}

ZLIB=`pkg-config --cflags zlib`
ZLIB_LIB=`pkg-config --libs zlib`

CFLAGS=\
	${IWSQL_DRIVER}\
	${GTK}\
	${ICU}\
	${DECN}\
	${RULER}\
	${GEOM}\
	${GMODULE}\
	${ZINT}\
	${ZLIB}\
	-pthread\
	-Wall\
	-std=c99\
	-pedantic\
	-ggdb

CXXFLAGS:=${CFLAGS}

ALL_LIB=\
	${GTK_LIB}\
	${ICU4_LIB}\
	${ICU_LIB}\
	${DECN_LIB}\
	${RULER_LIB}\
	${GEOM_LIB}\
	${GMODULE_LIB}\
	${ZINT_LIB}\
	${ZLIB_LIB}\
	${LDFLAGS}\
	-lstdc++\
	-lm\

IWRITE_OBJECTS=\
	cmd.o\
	copybuf.o\
	database_aspect.o\
	database_aspect_property.o\
	database_config.o\
	database_field.o\
	database_field_property.o\
	database_session.o\
	driver_config.o\
	error.o\
	export_config.o\
	export_csv.o\
	export.o\
	export_page_setup_property.o\
	export_spec.o\
	global_common.o\
	handles.o\
	item_circle.o\
	item_circle_property.o\
	item_common_attr.o\
	item_common_base.o\
	item_common_box.o\
	item_common_circle.o\
	item_common_line.o\
	item_common_lookup.o\
	item_date.o\
	item_date_property.o\
	item_fbarcode.o\
	item_fbarcode_property.o\
	item_fimage.o\
	item_fimage_property.o\
	item_fnumber.o\
	item_fnumber_property.o\
	item_frame.o\
	item_frame_property.o\
	item_fsum.o\
	item_fsum_property.o\
	item_ftext.o\
	item_ftext_property.o\
	item_image.o\
	item_image_property.o\
	item_line.o\
	item_line_property.o\
	item.o\
	item_page_number.o\
	item_page_number_property.o\
	item_property.o\
	item_selection.o\
	item_text.o\
	item_text_property.o\
	iwr_page_menu.o\
	iwr_page.o\
	iwsql_dll.o\
	label.o\
	label_page_setup_property.o\
	label_paper.o\
	label_pdf.o\
	label_spec.o\
	layout_break_property.o\
	layout.o\
	layout_page_setup_property.o\
	layout_pdf.o\
	layout_spec.o\
	main.o\
	mainw.o\
	menu.o\
	option.o\
	paper.o\
	pixbuf.o\
	query_exec.o\
	query.o\
	query_property.o\
	report.o\
	report_util.o\
	rw.o\
	sql.o\
	symbology.o\
	version.o\
	xml.o

includes = ${wildcard *.h}

.PHONY: all
all: icu/libicu.a decNumber/libdecnumber.a\
	geometry/libgeometry.a zint/libzint.a iwrite

iwrite : ${IWRITE_OBJECTS}
	${CC} -o $@ ${IWRITE_OBJECTS} ${ALL_LIB} 

%.o : %.c ${includes}
	${CC} -c ${CFLAGS} -o $@ $< 2> $@.err

item_common_lookup.o: item_common_lookup_gp.c

item_common_lookup_gp.c: item_common_lookup.gperf
	gperf -7 -D -t -L 'ANSI-C' item_common_lookup.gperf --output-file=item_common_lookup_gp.c

icu/libicu.a:
	@cd icu && ${MAKE}

decNumber/libdecnumber.a:
	@cd decNumber && ${MAKE}

geometry/libgeometry.a:
	@cd geometry && ${MAKE}

zint/libzint.a:
	@cd zint && ${MAKE}

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.so
	rm -f iwrite

=== drivers/oracle/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# Copyright (c) 2015, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RANLIB=ranlib

# TODO: use ORACLE_HOME ?

INC= -I ../include \
	-I /usr/include/oracle/12.1/client64/ \
	-I /opt/oracle/instantclient_12_1/sdk/include

LDFLAGS= \
	-L /usr/lib/oracle/12.1/client64/lib \
	-L /opt/oracle/instantclient_12_1 \
	-l mql1\
	-l ipc1\
	-l nnz12\
	-l ons\
	-l clntshcore\
	-l clntsh \
	-l occi 

CXXFLAGS+=-D_GLIBCXX_USE_CXX11_ABI=0
CXXFLAGS+=-fPIC -Wall -ansi -pedantic -Wno-variadic-macros -ggdb ${INC}

OBJECTS=\
	iwsql_attr_delete.o\
	iwsql_connect.o\
	iwsql_delete.o\
	iwsql_exec.o\
	iwsql_new.o\
	iwsql_next.o\
	iwsql_result.o\
	iwsql_type_translate.o

TEST_OBJECTS=\
	test.o

includes = ${wildcard *.h}

.PHONY: all
all: libs test

test: ${TEST_OBJECTS} libs
	${CXX} -o $@ ${TEST_OBJECTS} libiwsql_oracle.a ${LDFLAGS}

.PHONY: libs
libs: libiwsql_oracle.so libiwsql_oracle.a

libiwsql_oracle.so: ${OBJECTS}
	${CXX} -shared -o $@ $? ${LDFLAGS}

libiwsql_oracle.a: ${OBJECTS}
	${AR} rvc $@ $?
	${RANLIB} $@

%.o : %.c ${includes}
	${CXX} -c ${CXXFLAGS} -o $@ $< 2> $@.err

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.so
	rm -f test

=== drivers/postgres/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# Copyright (c) 2015-2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RANLIB=ranlib

UNAME:= $(shell uname)

INC= -I../include

ifeq ($(UNAME), Linux)

INC+= -I/usr/include/postgresql/server
INC+= -I/usr/include/pgsql/server

# postgressql 9.4 (Debian)
INC+= -I/usr/include/postgresql
INC+= -I/usr/include/postgresql/9.4/server

LDFLAGS= -lpq

endif

ifeq ($(UNAME), NetBSD)

INC+= -I/usr/pkg/include/
INC+= -I/usr/pkg/include/postgresql/server
LDFLAGS= -L /usr/pkg/lib -lpq

endif

ifeq ($(UNAME), OpenBSD)

INC+= -I /usr/local/include/postgresql/
INC+= -I /usr/local/include/postgresql/server/
LDFLAGS= -L /usr/local/lib -lpq

endif

ifeq ($(UNAME), FreeBSD)

INC+= -I /usr/local/include
INC+= -I /usr/local/include/postgresql/
INC+= -I /usr/local/include/postgresql/server/
LDFLAGS= -L /usr/local/lib -lpq

endif

CXXFLAGS+=-fPIC -Wall -ansi -pedantic -Wno-variadic-macros -ggdb ${INC}

OBJECTS=\
	iwsql_attr_delete.o\
	iwsql_connect.o\
	iwsql_delete.o\
	iwsql_error.o\
	iwsql_exec.o\
	iwsql_new.o\
	iwsql_next.o\
	iwsql_result.o\
	iwsql_oid_translate.o

includes = ${wildcard *.h}

.PHONY: libs
libs: libiwsql_pq.so libiwsql_pq.a

libiwsql_pq.so: ${OBJECTS}
	${CXX} -shared -o $@ $? ${LDFLAGS}

libiwsql_pq.a: ${OBJECTS}
	${AR} rvc $@ $?
	${RANLIB} $@

%.o : %.cxx ${includes}
	${CXX} -c ${CXXFLAGS} -o $@ $< 2> $@.err

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.so

=== src/GtkWidgetSkeleton/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
#  CC0 1.0 Universal (CC0 1.0) Public Domain Dedication
#
# Deriviative works may remove this license dedication and incorporate
# their own.
# 
# GTK widget skeleton template

RANLIB=ranlib

GLIB=`pkg-config glib-2.0 --cflags`
GLIB_LIB=`pkg-config glib-2.0 --libs`

GTK=`pkg-config gtk+-3.0 --cflags`
GTK_LIB=`pkg-config gtk+-3.0 --libs`

includes = ${wildcard *.h}

CFLAGS=\
	${GLIB}\
	${GTK}\
	-pthread\
	-Wall\
	-ansi\
	-pedantic\
	-ggdb

LIBSKEL_OBJECTS=\
	comp.o\
	skel.o

libskel.a: ${LIBSKEL_OBJECTS}
	${AR} rvc $@ $?
	${RANLIB} $@

%.o : %.c ${includes}
	${CC} -c ${CFLAGS} -o $@ $< 2> $@.err

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.so

=== src/decNumber/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2015, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RANLIB=ranlib

includes = ${wildcard *.h}

CFLAGS=\
	-O3\
	-Wall\
	-pedantic\
	-ggdb

LIBDECNUMBER_OBJECTS=\
	decContext.o\
	decDouble.o\
	decimal128.o\
	decimal32.o\
	decimal64.o\
	decNumber.o\
	decPacked.o\
	decQuad.o\
	decSingle.o

.PHONY: all
all: libdecnumber.a example1 example2 example3 example4 example5 example6 example7 example8 

libdecnumber.a: ${LIBDECNUMBER_OBJECTS}
	${AR} rvc $@ $?
	${RANLIB} $@

example1: example1.o libdecnumber.a
	${CC} -o $@ $? 

example2: example2.o libdecnumber.a
	${CC} -o $@ $? 

example3: example3.o libdecnumber.a
	${CC} -o $@ $? 

example4: example4.o libdecnumber.a
	${CC} -o $@ $? 

example5: example5.o libdecnumber.a
	${CC} -o $@ $? 

example6: example6.o libdecnumber.a
	${CC} -o $@ $? 

example7: example7.o libdecnumber.a
	${CC} -o $@ $? 

example8: example8.o libdecnumber.a
	${CC} -o $@ $? 

%.o : %.c ${includes}
	${CC} -c ${CFLAGS} -o $@ $< 2> $@.err

clean:
	@rm -f *.o
	@rm -f *.o.err
	@rm -f *.a
	@rm -f *.so
	@rm -f example1 example2 example3 example4 example5 example6 example7 example8

=== src/geometry/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2015, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RANLIB=ranlib

includes = ${wildcard *.h}

CFLAGS=\
	-pthread\
	-Wall\
	-ansi\
	-std=c99\
	-pedantic\
	-ggdb

LIBGEOMETRY_OBJECTS=\
	geom_ellipse.o\
	geom_line.o\
	geom_rectvect.o\
	pnpoly.o

libgeometry.a: ${LIBGEOMETRY_OBJECTS}
	${AR} rvc $@ $?
	${RANLIB} $@

%.o : %.c ${includes}
	${CC} -c ${CFLAGS} -o $@ $< 2> $@.err

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.so

=== src/icu/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2015, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RANLIB=ranlib

ICU4=`pkg-config --cflags icu-uc icu-io`
ICU4_LIB=`pkg-config --libs icu-uc icu-io`

includes= ${wildcard *.h}

CXXFLAGS=\
	${ICU4}\
	-pthread\
	-Wall\
	-ansi\
	-pedantic\
	-ggdb

LIBICU_OBJECTS=\
	icu_date_to_textual.o\
	icu_double_to_locale.o\
	icu_double_to_textual.o\
	icu_integer_to_locale.o\
	icu_monetary_to_locale.o

test: libicu.a test.o
	${CXX} ${CXXFLAGS} -o $@ test.o libicu.a ${ICU4_LIB}

libicu.a: ${LIBICU_OBJECTS}
	${AR} rvc $@ $?
	${RANLIB} $@

%.o : %.cxx ${includes}
	${CXX} -c ${CXXFLAGS} -o $@ $< 2> $@.err

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.so
	rm -f test

=== src/zint/Makefile ===
# Linux makefile for libzint
#
# make			compiles
# make install		copies to /usr/local/lib
# make uninstall	removes library
# make clean		cleans up a previous compilation and any object or editor files
#

UNAME:= $(shell uname)

ifeq ($(UNAME), Linux)
PNG_LIB= -l png
else
PNG_LIB= -l png16
endif

ZINT_VERSION:=-DZINT_VERSION=\"2.4.4\"

CAIRO=`pkg-config cairo --cflags`
CAIRO_LIB=`pkg-config cairo --libs`

# CC := gcc
INCLUDE := -I/usr/include ${CAIRO}
CFLAGS := -g ${INCLUDE}

prefix := /usr
includedir := $(prefix)/include
libdir := $(prefix)/lib
DESTDIR :=

COMMON:= common.c render.c png.c library.c ps.c large.c reedsol.c gs1.c svg.c cairo.c
COMMON_OBJ:= common.o render.o png.o library.o ps.o large.o reedsol.o gs1.o svg.o cairo.o
ONEDIM:= code.c code128.c 2of5.c upcean.c telepen.c medical.c plessey.c rss.c
ONEDIM_OBJ:= code.o code128.o 2of5.o upcean.o telepen.o medical.o plessey.o rss.o
POSTAL:= postal.c auspost.c imail.c
POSTAL_OBJ:= postal.o auspost.o imail.o
TWODIM:= code16k.c dmatrix.c pdf417.c qr.c maxicode.c composite.c aztec.c code49.c code1.c gridmtx.c
TWODIM_OBJ:= code16k.o dmatrix.o pdf417.o qr.o maxicode.o composite.o aztec.o code49.o code1.o gridmtx.o
OBJS:=$(COMMON_OBJ) $(ONEDIM_OBJ) $(TWODIM_OBJ) $(POSTAL_OBJ)
LIBS:= -lz -lm ${PNG_LIB} ${CAIRO_LIB}

all: libzint.a libzint.so

libzint.a: $(OBJS)
	$(AR) rcs libzint.a $(OBJS)
 
libzint.so.2.4.4: $(OBJS)
	$(CC) $(CFLAGS) $(ZINT_VERSION) -shared -Wl,-soname,libzint.so -o libzint.so.2.4.4 $(INCLUDE) $(OBJS) $(LIBS)

libzint.so: libzint.so.2.4.4
	rm -f libzint.so
	ln -s libzint.so.* libzint.so

%.o: %.c
	$(CC) -Wall -fPIC $(CFLAGS) $(ZINT_VERSION) -c -o $@ $<

.PHONY: install uninstall clean dist

install:
	test "$(UID)" = "0" && ldconfig -n $(PWD) || true
	install -d $(DESTDIR)$(libdir)
	mv libzint.* $(DESTDIR)$(libdir)
	install -D -p --mode=0644 zint.h $(DESTDIR)$(includedir)/zint.h

uninstall:
	rm $(DESTDIR)$(libdir)/libzint.*
	rm $(DESTDIR)$(includedir)/zint.h

clean:
	rm -f libzint.* *.o *.a *~

=== drivers/sqlite3/amalgamation/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# Copyright (c) 2015, Mark J. Olesen
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RANLIB=ranlib

UNAME:= $(shell uname)

ifeq ($(UNAME), Linux)
LDFLAGS+= -ldl
endif

# SQLOPTS=-D SQLITE_ENABLE_COLUMN_METADATA -D SQLITE_OMIT_UTF16
SQLOPTS=-D SQLITE_OMIT_UTF16

INC+=-I./

CFLAGS+=${SQLOPTS} -fPIC -Wall -pedantic -ggdb ${INC}

LIB_OBJECTS=\
	sqlite3.o

SHELL_OBJECTS=\
	shell.o

includes = ${wildcard *.h}

.PHONY: all
all: shell libs

.PHONY: libs
libs: libsqlite3.so libsqlite3.a

libsqlite3.so: ${LIB_OBJECTS}
	${CC} -shared -o $@ $? 

libsqlite3.a: ${LIB_OBJECTS}
	${AR} rvc $@ $?
	${RANLIB} $@

shell: ${SHELL_OBJECTS} libs
	${CC} -o $@ ${SHELL_OBJECTS} -L./ -lsqlite3 -lpthread ${LDFLAGS}

%.o : %.c ${includes}
	${CC} -c ${CFLAGS} -o $@ $< 2> $@.err

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.so
	rm -f shell

=== packaging/debian/changelog ===
iwrite (3.0.1.0-1) unstable; urgency=low

  * Add edit/undo
  * Bug fixes

 -- Mark Olesen <markjolesen@gmail.com>  Sun, 05 Jun 2016 06:47:46 -0700

iwrite (2.0.1.0-1) unstable; urgency=low

  * Use XML instead of BSON

 -- Mark Olesen <markjolesen@gmail.com>  Fri, 12 Feb 2016 01:10:17 -0700

iwrite (1.0.1.4-1) unstable; urgency=low

  * Initial beta release.

 -- Mark Olesen <markjolesen@gmail.com>  Tue, 12 Jan 2016 01:22:49 -0700

=== packaging/abs/PKGBUILD ===
pkgname=iwrite
pkgver=3.0.1.0
pkgrel=1
pkgdesc='SQL report writer'
arch=('i686' 'x86_64')
url='http://www.nongnu.org/iwrite/'
license=('BSD')
depends=('icu' 'gtk3')
# makedepends need to add postgres mariadb or mysql client + oracle client libs
source=(
"http://download.savannah.gnu.org/releases/iwrite/$pkgname-$pkgver.tar.gz"
"http://download.savannah.gnu.org/releases/iwrite/$pkgname-$pkgver.tar.gz.sig"
)

md5sums=('SKIP' 'SKIP')


build() {
  cd "$srcdir/$pkgname-$pkgver"
  make
}

package() {
  cd "$srcdir/$pkgname-$pkgver"
  make DESTDIR="$pkgdir" LIBDIR=/usr/lib install
}

=== packaging/debian/control ===
Source: iwrite
Maintainer: Mark J. Olesen <markjolesen@gmail.com>
Section: misc
Priority: optional
Standards-Version: 3.9.2
Homepage: http://www.nongnu.org/iwrite/
Build-Depends: debhelper (>=9), libicu-dev, libgtk-3-dev, texlive-latex-recommended

Package: iwrite
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SQL Report Writer
	Iwrite is a free software package for generating basic SQL based reports.

=== packaging/debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_shlibdeps:
	dh_shlibdeps -X libiwsql_oracle.so -X libiwsql_pq.so -X libiwsql_mariadb.so -X libiwsql_sqlite3.so

#       dh_shlibdeps -l /opt/oracle/instantclient_12_1/ --dpkg-shlibdeps-params=--ignore-missing-info
